#import "InstallPlugin.h"

@implementation InstallPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"install_plugin"
            binaryMessenger:[registrar messenger]];
  InstallPlugin* instance = [[InstallPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"getPlatformVersion" isEqualToString:call.method]) {
    result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
  }else if ([@"gotoAppStore" isEqualToString:call.method]) {
      NSString *urlString = call.arguments[@"urlString"];
      [self gotoAppStore:urlString result:result];
  } else {
    result(FlutterMethodNotImplemented);
  }
}

-(void)gotoAppStore:(NSString *)url result:(FlutterResult)result{
    NSURL *urlStore = [NSURL URLWithString:url];
    if (@available(iOS 10.0, *)){
        [[UIApplication sharedApplication] openURL:urlStore options:@{UIApplicationOpenURLOptionsSourceApplicationKey:@YES} completionHandler:^(BOOL success) {
            if (success) {
                result(@YES);
            }else{
                result(@NO);
            }
        }];
    }else{
        BOOL success = [[UIApplication sharedApplication]openURL:urlStore];
        if (success) {
            result(@YES);
        }else{
            result(@NO);
        }
    }
}

@end
